## org.firebirdsql.jdbc
Class AbstractDatabaseMetaData

    java.lang.Object
      org.firebirdsql.jdbc.AbstractDatabaseMetaData

All Implemented Interfaces:
  DatabaseMetaData, Wrapper, FirebirdDatabaseMetaData

Direct Known Subclasses:
  FBDatabaseMetaData

    public abstract class AbstractDatabaseMetaData

extends Object
implements FirebirdDatabaseMetaData

Comprehensive information about the database as a whole.

Many of the methods here return lists of information in the form of `ResultSet` objects. You can use the normal `ResultSet` methods such as getString and getInt to retrieve the data from these `ResultSet`. If a given form of metadata is not available, these methods should throw an SQLException.

Some of these methods take arguments that are String patterns. These arguments all have names such as fooPattern. Within a pattern String, "%" means match any substring of 0 or more characters, and "_" means match any one character. Only metadata entries matching the search pattern are returned. If a search pattern argument is set to a null ref, that argument's criteria will be dropped from the search.

An `SQLException` will be thrown if a driver does not support a meta data method. In the case of methods that return a `ResultSet`, either a `ResultSet` (which may be empty) is returned or a SQLException is thrown.

Version:
  1.0
Author:
  David Jencks

Field Summary
`static String[]` `ALL_TYPES`
`static String` `GET_COLUMNS_END`
`static String` `SYSTEM_TABLE`
`static String` `TABLE`
`static String` `VIEW`

Fields inherited from interface java.sql.DatabaseMetaData

`attributeNoNulls, attributeNullable, attributeNullableUnknown, bestRowNotPseudo, bestRowPseudo, bestRowSession, bestRowTemporary, bestRowTransaction, bestRowUnknown, columnNoNulls, columnNullable, columnNullableUnknown, functionColumnIn, functionColumnInOut, functionColumnOut, functionColumnResult, functionColumnUnknown, functionNoNulls, functionNoTable, functionNullable, functionNullableUnknown, functionResultUnknown, functionReturn, functionReturnsTable, importedKeyCascade, importedKeyInitiallyDeferred, importedKeyInitiallyImmediate, importedKeyNoAction, importedKeyNotDeferrable, importedKeyRestrict, importedKeySetDefault, importedKeySetNull, procedureColumnIn, procedureColumnInOut, procedureColumnOut, procedureColumnResult, procedureColumnReturn, procedureColumnUnknown, procedureNoNulls, procedureNoResult, procedureNullable, procedureNullableUnknown, procedureResultUnknown, procedureReturnsResult, sqlStateSQL, sqlStateSQL99, sqlStateXOpen, tableIndexClustered, tableIndexHashed, tableIndexOther, tableIndexStatistic, typeNoNulls, typeNullable, typeNullableUnknown, typePredBasic, typePredChar, typePredNone, typeSearchable, versionColumnNotPseudo, versionColumnPseudo, versionColumnUnknown`

Method Summary
`boolean` `allProceduresAreCallable()` Can all the procedures returned by getProcedures be called by the current user?
`boolean` `allTablesAreSelectable()` Can all the tables returned by getTable be SELECTed by the current user?
`boolean` `dataDefinitionCausesTransactionCommit()` Does a data definition statement within a transaction force the transaction to commit?
`boolean` `dataDefinitionIgnoredInTransactions()` Is a data definition statement within a transaction ignored?
`boolean` `deletesAreDetected(int type)` Indicates whether or not a visible row delete can be detected by calling ResultSet.rowDeleted().
`boolean` `doesMaxRowSizeIncludeBlobs()` Did getMaxRowSize() include LONGVARCHAR and LONGVARBINARY blobs?
`ResultSet` `doQuery(String sql, List params)` Execute an sql query with a given set of parameters.
`ResultSet` `getAttributes(String param1, String param2, String param3, String param4)` This operation is not supported
`ResultSet` `getBestRowIdentifier(String catalog, String schema, String table, int scope, boolean nullable)` Gets a description of a table's optimal set of columns that uniquely identifies a row.
`ResultSet` `getCatalogs()` Gets the catalog names available in this database.
`String` `getCatalogSeparator()` What's the separator between catalog and table name?
`String` `getCatalogTerm()` What's the database vendor's preferred term for "catalog"?
`ResultSet` `getColumnPrivileges(String catalog, String schema, String table, String columnNamePattern)` Gets a description of the access rights for a table's columns.
`ResultSet` `getColumns(String catalog, String schemaPattern, String tableNamePattern, String columnNamePattern)` Gets a description of table columns available in the specified catalog.
`Connection` `getConnection()` Retrieves the connection that produced this metadata object.
`ResultSet` `getCrossReference(String primaryCatalog, String primarySchema, String primaryTable, String foreignCatalog, String foreignSchema, String foreignTable)` Gets a description of the foreign key columns in the foreign key table that reference the primary key columns of the primary key table (describe how one table imports another's key).
`int` `getDatabaseMajorVersion()` Get the major version number of the database.
`int` `getDatabaseMinorVersion()` Get the minor version number of the database.
`String` `getDatabaseProductName()` What's the name of this database product?
`String` `getDatabaseProductVersion()` What's the version of this database product?
`int` `getDefaultTransactionIsolation()` What's the database's default transaction isolation level? The values are defined in `java.sql.Connection`.
`int` `getDriverMajorVersion()` What's this JDBC driver's major version number?
`int` `getDriverMinorVersion()` What's this JDBC driver's minor version number?
`String` `getDriverName()` What's the name of this JDBC driver?
`String` `getDriverVersion()` What's the version of this JDBC driver?
`ResultSet` `getExportedKeys(String catalog, String schema, String table)` Gets a description of the foreign key columns that reference a table's primary key columns (the foreign keys exported by a table).
`String` `getExtraNameCharacters()` Gets all the "extra" characters that can be used in unquoted identifier names (those beyond a-z, A-Z, 0-9 and _).
`String` `getIdentifierQuoteString()` What's the string used to quote SQL identifiers? This returns a space " " if identifier quoting isn't supported.
`ResultSet` `getImportedKeys(String catalog, String schema, String table)` Gets a description of the primary key columns that are referenced by a table's foreign key columns (the primary keys imported by a table).
`ResultSet` `getIndexInfo(String catalog, String schema, String table, boolean unique, boolean approximate)` Gets a description of a table's indices and statistics.
`int` `getJDBCMajorVersion()` Get the JDBC major version for this driver.
`int` `getJDBCMinorVersion()` Get the JDBC minor version for this driver
`int` `getMaxBinaryLiteralLength()` How many hex characters can you have in an inline binary literal?
`int` `getMaxCatalogNameLength()` What's the maximum length of a catalog name?
`int` `getMaxCharLiteralLength()` What's the max length for a character literal?
`int` `getMaxColumnNameLength()` What's the limit on column name length?
`int` `getMaxColumnsInGroupBy()` What's the maximum number of columns in a "GROUP BY" clause?
`int` `getMaxColumnsInIndex()` What's the maximum number of columns allowed in an index?
`int` `getMaxColumnsInOrderBy()` What's the maximum number of columns in an "ORDER BY" clause?
`int` `getMaxColumnsInSelect()` What's the maximum number of columns in a "SELECT" list?
`int` `getMaxColumnsInTable()` What's the maximum number of columns in a table?
`int` `getMaxConnections()` How many active connections can we have at a time to this database?
`int` `getMaxCursorNameLength()` What's the maximum cursor name length?
`int` `getMaxIndexLength()` Retrieves the maximum number of bytes for an index, including all of the parts of the index.
`int` `getMaxProcedureNameLength()` What's the maximum length of a procedure name?
`int` `getMaxRowSize()` What's the maximum length of a single row?
`int` `getMaxSchemaNameLength()` What's the maximum length allowed for a schema name?
`int` `getMaxStatementLength()` What's the maximum length of an SQL statement?
`int` `getMaxStatements()` How many active statements can we have open at one time to this database?
`int` `getMaxTableNameLength()` What's the maximum length of a table name?
`int` `getMaxTablesInSelect()` What's the maximum number of tables in a SELECT statement?
`int` `getMaxUserNameLength()` What's the maximum length of a user name?
`String` `getNumericFunctions()` Gets a comma-separated list of math functions.
`ResultSet` `getPrimaryKeys(String catalog, String schema, String table)` Gets a description of a table's primary key columns.
`ResultSet` `getProcedureColumns(String catalog, String schemaPattern, String procedureNamePattern, String columnNamePattern)` Gets a description of a catalog's stored procedure parameters and result columns.
`ResultSet` `getProcedures(String catalog, String schemaPattern, String procedureNamePattern)` Gets a description of the stored procedures available in a catalog.
`String` `getProcedureSourceCode(String procedureName)` Get the source of a stored procedure.
`String` `getProcedureTerm()` What's the database vendor's preferred term for "procedure"?
`int` `getResultSetHoldability()` Retrieves the default holdability of this `ResultSet`.
`ResultSet` `getSchemas()` Gets the schema names available in this database.
`String` `getSchemaTerm()` What's the database vendor's preferred term for "schema"?
`String` `getSearchStringEscape()` Gets the string that can be used to escape wildcard characters.
`String` `getSQLKeywords()` Gets a comma-separated list of all a database's SQL keywords that are NOT also SQL92 keywords.
`int` `getSQLStateType()` Indicates whether the SQLSTATEs returned by SQLException.getSQLState is X/Open (now known as Open Group) SQL CLI or SQL99
`String` `getStringFunctions()` Gets a comma-separated list of string functions.
`ResultSet` `getSuperTables(String catalog, String schemaPattern, String tableNamePattern)` Retrieves a description of the table hierarchies defined in a particular schema in this database.
`ResultSet` `getSuperTypes(String catalog, String schemaPattern, String tableNamePattern)` Retrieves a description of the user-defined type (UDT) hierarchies defined in a particular schema in this database.
`String` `getSystemFunctions()` Gets a comma-separated list of system functions.
`ResultSet` `getTablePrivileges(String catalog, String schemaPattern, String tableNamePattern)` Gets a description of the access rights for each table available in a catalog.
`ResultSet` `getTables(String catalog, String schemaPattern, String tableNamePattern, String[] types)` Gets a description of tables available in a catalog.
`ResultSet` `getTableTypes()` Gets the table types available in this database.
`String` `getTimeDateFunctions()` Gets a comma-separated list of time and date functions.
`String` `getTriggerSourceCode(String triggerName)` Get the source of a trigger.
`ResultSet` `getTypeInfo()` Gets a description of all the standard SQL types supported by this database.
`ResultSet` `getUDTs(String catalog, String schemaPattern, String typeNamePattern, int[] types)` Gets a description of the user-defined types defined in a particular schema.
`String` `getURL()` What's the url for this database?
`String` `getUserName()` What's our user name as known to the database?
`ResultSet` `getVersionColumns(String catalog, String schema, String table)` Gets a description of a table's columns that are automatically updated when any value in a row is updated.
`String` `getViewSourceCode(String viewName)` Get the source of a view.
`boolean` `hasNoWildcards(String pattern)` Determine if there are no SQL wildcard characters ('%' or '_') in the given pattern.
`boolean` `insertsAreDetected(int type)` Indicates whether or not a visible row insert can be detected by calling ResultSet.rowInserted().
`boolean` `isCatalogAtStart()` Does a catalog appear at the start of a qualified table name? (Otherwise it appears at the end)
`boolean` `isReadOnly()` Is the database in read-only mode?
`boolean` `locatorsUpdateCopy()` Describe `locatorsUpdateCopy` method here.
`boolean` `nullPlusNonNullIsNull()` Retrieves whether concatenations between NULL and non-NULL values equal NULL.
`boolean` `nullsAreSortedAtEnd()` Are NULL values sorted at the end regardless of sort order?
`boolean` `nullsAreSortedAtStart()` Are NULL values sorted at the start regardless of sort order?
`boolean` `nullsAreSortedHigh()` Are NULL values sorted high?
`boolean` `nullsAreSortedLow()` Are NULL values sorted low?
`boolean` `othersDeletesAreVisible(int type)` Indicates whether deletes made by others are visible.
`boolean` `othersInsertsAreVisible(int type)` Indicates whether inserts made by others are visible.
`boolean` `othersUpdatesAreVisible(int type)` Indicates whether updates made by others are visible.
`boolean` `ownDeletesAreVisible(int type)` Indicates whether a result set's own deletes are visible.
`boolean` `ownInsertsAreVisible(int type)` Indicates whether a result set's own inserts are visible.
`boolean` `ownUpdatesAreVisible(int type)` Indicates whether a result set's own updates are visible.
`boolean` `storesLowerCaseIdentifiers()` Does the database treat mixed case unquoted SQL identifiers as case insensitive and store them in lower case?
`boolean` `storesLowerCaseQuotedIdentifiers()` Does the database treat mixed case quoted SQL identifiers as case insensitive and store them in lower case?
`boolean` `storesMixedCaseIdentifiers()` Does the database treat mixed case unquoted SQL identifiers as case insensitive and store them in mixed case?
`boolean` `storesMixedCaseQuotedIdentifiers()` Does the database treat mixed case quoted SQL identifiers as case insensitive and store them in mixed case?
`boolean` `storesUpperCaseIdentifiers()` Does the database treat mixed case unquoted SQL identifiers as case insensitive and store them in upper case?
`boolean` `storesUpperCaseQuotedIdentifiers()` Does the database treat mixed case quoted SQL identifiers as case insensitive and store them in upper case?
`String` `stripEscape(String pattern)` Strips all backslash-escapes from a string.
`String` `stripQuotes(String pattern, boolean uppercase)` Strips a leading and trailing quote (double or single) from a string.
`boolean` `supportsAlterTableWithAddColumn()` Is "ALTER TABLE" with add column supported?
`boolean` `supportsAlterTableWithDropColumn()` Is "ALTER TABLE" with drop column supported?
`boolean` `supportsANSI92EntryLevelSQL()` Is the ANSI92 entry level SQL grammar supported? All JDBC CompliantTM drivers must return true.
`boolean` `supportsANSI92FullSQL()` Is the ANSI92 full SQL grammar supported?
`boolean` `supportsANSI92IntermediateSQL()` Is the ANSI92 intermediate SQL grammar supported?
`boolean` `supportsBatchUpdates()` Indicates whether the driver supports batch updates.
`boolean` `supportsCatalogsInDataManipulation()` Can a catalog name be used in a data manipulation statement?
`boolean` `supportsCatalogsInIndexDefinitions()` Can a catalog name be used in an index definition statement?
`boolean` `supportsCatalogsInPrivilegeDefinitions()` Can a catalog name be used in a privilege definition statement?
`boolean` `supportsCatalogsInProcedureCalls()` Can a catalog name be used in a procedure call statement?
`boolean` `supportsCatalogsInTableDefinitions()` Can a catalog name be used in a table definition statement?
`boolean` `supportsColumnAliasing()` Is column aliasing supported?
`boolean` `supportsConvert()` Is the CONVERT function between SQL types supported? What is this??? my sql ref says CONVERT is a string encoding map!
`boolean` `supportsConvert(int fromType, int toType)` Retrieves whether CONVERT between the given SQL types supported.
`boolean` `supportsCoreSQLGrammar()` Is the ODBC Core SQL grammar supported?
`boolean` `supportsCorrelatedSubqueries()` Are correlated subqueries supported? A JDBC CompliantTM driver always returns true.
`boolean` `supportsDataDefinitionAndDataManipulationTransactions()` Are both data definition and data manipulation statements within a transaction supported?
`boolean` `supportsDataManipulationTransactionsOnly()` Are only data manipulation statements within a transaction supported?
`boolean` `supportsDifferentTableCorrelationNames()` If table correlation names are supported, are they restricted to be different from the names of the tables?
`boolean` `supportsExpressionsInOrderBy()` Are expressions in "ORDER BY" lists supported?
`boolean` `supportsExtendedSQLGrammar()` Is the ODBC Extended SQL grammar supported?
`boolean` `supportsFullOuterJoins()` Are full nested outer joins supported?
`boolean` `supportsGetGeneratedKeys()` Retrieves whether auto-generated keys can be retrieved after creation.
`boolean` `supportsGroupBy()` Is some form of "GROUP BY" clause supported?
`boolean` `supportsGroupByBeyondSelect()` Can a "GROUP BY" clause add columns not in the SELECT provided it specifies all the columns in the SELECT?
`boolean` `supportsGroupByUnrelated()` Can a "GROUP BY" clause use columns not in the SELECT?
`boolean` `supportsIntegrityEnhancementFacility()` Is the SQL Integrity Enhancement Facility supported?
`boolean` `supportsLikeEscapeClause()` Is the escape character in "LIKE" clauses supported? A JDBC CompliantTM driver always returns true.
`boolean` `supportsLimitedOuterJoins()` Is there limited support for outer joins? (This will be true if supportFullOuterJoins is true.)
`boolean` `supportsMinimumSQLGrammar()` Is the ODBC Minimum SQL grammar supported? All JDBC CompliantTM drivers must return true.
`boolean` `supportsMixedCaseIdentifiers()` Does the database treat mixed case unquoted SQL identifiers as case sensitive and as a result store them in mixed case? A JDBC CompliantTM driver will always return false.
`boolean` `supportsMixedCaseQuotedIdentifiers()` Does the database treat mixed case quoted SQL identifiers as case sensitive and as a result store them in mixed case? A JDBC CompliantTM driver will always return true.
`boolean` `supportsMultipleOpenResults()` Retrieves whether it is possible to have multiple `ResultSet` objects returned from a `CallableStatement` object simultaneously.
`boolean` `supportsMultipleResultSets()` Are multiple `ResultSet` from a single execute supported?
`boolean` `supportsMultipleTransactions()` Can we have multiple transactions open at once (on different connections)?
`boolean` `supportsNamedParameters()` Retrieve whether this database supports named parameters.
`boolean` `supportsNonNullableColumns()` Can columns be defined as non-nullable? A JDBC CompliantTM driver always returns true.
`boolean` `supportsOpenCursorsAcrossCommit()` Can cursors remain open across commits?
`boolean` `supportsOpenCursorsAcrossRollback()` Can cursors remain open across rollbacks?
`boolean` `supportsOpenStatementsAcrossCommit()` Can statements remain open across commits?
`boolean` `supportsOpenStatementsAcrossRollback()` Can statements remain open across rollbacks?
`boolean` `supportsOrderByUnrelated()` Can an "ORDER BY" clause use columns not in the SELECT statement?
`boolean` `supportsOuterJoins()` Is some form of outer join supported?
`boolean` `supportsPositionedDelete()` Is positioned DELETE supported?
`boolean` `supportsPositionedUpdate()` Is positioned UPDATE supported?
`boolean` `supportsResultSetConcurrency(int type, int concurrency)` Does the database support the concurrency type in combination with the given result set type?
`boolean` `supportsResultSetHoldability(int holdability)` Retrieves whether this database supports the given results holdability.
`boolean` `supportsResultSetType(int type)` Does the database support the given result set type?
`boolean` `supportsSavepoints()` Retrieves whether this database supports savepoints.
`boolean` `supportsSchemasInDataManipulation()` Can a schema name be used in a data manipulation statement?
`boolean` `supportsSchemasInIndexDefinitions()` Can a schema name be used in an index definition statement?
`boolean` `supportsSchemasInPrivilegeDefinitions()` Can a schema name be used in a privilege definition statement?
`boolean` `supportsSchemasInProcedureCalls()` Can a schema name be used in a procedure call statement?
`boolean` `supportsSchemasInTableDefinitions()` Can a schema name be used in a table definition statement?
`boolean` `supportsSelectForUpdate()` Is SELECT for UPDATE supported?
`boolean` `supportsStatementPooling()`
`boolean` `supportsStoredProcedures()` Are stored procedure calls using the stored procedure escape syntax supported?
`boolean` `supportsSubqueriesInComparisons()` Are subqueries in comparison expressions supported? A JDBC CompliantTM driver always returns true.
`boolean` `supportsSubqueriesInExists()` Are subqueries in 'exists' expressions supported? A JDBC CompliantTM driver always returns true.
`boolean` `supportsSubqueriesInIns()` Are subqueries in 'in' statements supported? A JDBC CompliantTM driver always returns true.
`boolean` `supportsSubqueriesInQuantifieds()` Are subqueries in quantified expressions supported? A JDBC CompliantTM driver always returns true.
`boolean` `supportsTableCorrelationNames()` Are table correlation names supported? A JDBC CompliantTM driver always returns true.
`boolean` `supportsTransactionIsolationLevel(int level)` Does this database support the given transaction isolation level?
`boolean` `supportsTransactions()` Are transactions supported? If not, invoking the method `commit` is a noop and the isolation level is TRANSACTION_NONE.
`boolean` `supportsUnion()` Is SQL UNION supported?
`boolean` `supportsUnionAll()` Is SQL UNION ALL supported?
`boolean` `updatesAreDetected(int type)` Indicates whether or not a visible row update can be detected by calling the method `ResultSet.rowUpdated`.
`boolean` `usesLocalFilePerTable()` Does the database use a file for each table?
`boolean` `usesLocalFiles()` Does the database store tables in a local file?

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface java.sql.DatabaseMetaData
`autoCommitFailureClosesAllResultSets, getClientInfoProperties, getFunctionColumns, getFunctions, getRowIdLifetime, getSchemas, supportsStoredFunctionsUsingCallSyntax`

Methods inherited from interface java.sql.Wrapper
`isWrapperFor, unwrap`

Field Detail

### TABLE

    public static final String TABLE

See Also:
  Constant Field Values

### SYSTEM_TABLE

    public static final String SYSTEM_TABLE

See Also:
  Constant Field Values

### VIEW

    public static final String VIEW

See Also:
  Constant Field Values

### ALL_TYPES

    public static final String[] ALL_TYPES

### GET_COLUMNS_END

    public static final String GET_COLUMNS_END

See Also:
  Constant Field Values

Method Detail

### allProceduresAreCallable

    public boolean allProceduresAreCallable()
                                     throws SQLException

  Can all the procedures returned by getProcedures be called by the current user?

  Specified by:
    `allProceduresAreCallable` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### allTablesAreSelectable

    public boolean allTablesAreSelectable()
                                   throws SQLException

  Can all the tables returned by getTable be SELECTed by the current user?

  Specified by:
    `allTablesAreSelectable` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### getURL

    public String getURL()
                  throws SQLException

  What's the url for this database?

  Specified by:
    `getURL` in interface `DatabaseMetaData`
  Returns:
    the url or null if it cannot be generated
  Throws:
    `SQLException` - if a database access error occurs

### getUserName

    public String getUserName()
                       throws SQLException

  What's our user name as known to the database?

  Specified by:
    `getUserName` in interface `DatabaseMetaData`
  Returns:
    our database user name
  Throws:
    `SQLException` - if a database access error occurs

### isReadOnly

    public boolean isReadOnly()
                       throws SQLException

  Is the database in read-only mode?

  Specified by:
    `isReadOnly` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### nullsAreSortedHigh

    public boolean nullsAreSortedHigh()
                               throws SQLException

  Are NULL values sorted high?

  Specified by:
    `nullsAreSortedHigh` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### nullsAreSortedLow

    public boolean nullsAreSortedLow()
                              throws SQLException

  Are NULL values sorted low?

  Specified by:
    `nullsAreSortedLow` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### nullsAreSortedAtStart

    public boolean nullsAreSortedAtStart()
                                  throws SQLException

  Are NULL values sorted at the start regardless of sort order?

  Specified by:
    `nullsAreSortedAtStart` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### nullsAreSortedAtEnd

    public boolean nullsAreSortedAtEnd()
                                throws SQLException

  Are NULL values sorted at the end regardless of sort order?

  Specified by:
    `nullsAreSortedAtEnd` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### getDatabaseProductName

    public String getDatabaseProductName()
                                  throws SQLException

  What's the name of this database product?

  Specified by:
    `getDatabaseProductName` in interface `DatabaseMetaData`
  Returns:
    database product name
  Throws:
    `SQLException` - if a database access error occurs

### getDatabaseProductVersion

    public String getDatabaseProductVersion()
                                     throws SQLException

  What's the version of this database product?

  Specified by:
    `getDatabaseProductVersion` in interface `DatabaseMetaData`
  Returns:
    database version
  Throws:
    `SQLException` - if a database access error occurs

### getDriverName

    public String getDriverName()
                         throws SQLException

  What's the name of this JDBC driver?

  Specified by:
    `getDriverName` in interface `DatabaseMetaData`
  Returns:
    JDBC driver name
  Throws:
    `SQLException` - if a database access error occurs

### getDriverVersion

    public String getDriverVersion()
                            throws SQLException

  What's the version of this JDBC driver?

  Specified by:
    `getDriverVersion` in interface `DatabaseMetaData`
  Returns:
    JDBC driver version
  Throws:
    `SQLException` - if a database access error occurs

### getDriverMajorVersion

    public int getDriverMajorVersion()

  What's this JDBC driver's major version number?

  Specified by:
    `getDriverMajorVersion` in interface `DatabaseMetaData`
  Returns:
    JDBC driver major version

### getDriverMinorVersion

    public int getDriverMinorVersion()

  What's this JDBC driver's minor version number?

  Specified by:
    `getDriverMinorVersion` in interface `DatabaseMetaData`
  Returns:
    JDBC driver minor version number

### usesLocalFiles

    public boolean usesLocalFiles()
                           throws SQLException

  Does the database store tables in a local file?

  Specified by:
    `usesLocalFiles` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### usesLocalFilePerTable

    public boolean usesLocalFilePerTable()
                                  throws SQLException

  Does the database use a file for each table?

  Specified by:
    `usesLocalFilePerTable` in interface `DatabaseMetaData`
  Returns:
    true if the database uses a local file for each table
  Throws:
    `SQLException` - if a database access error occurs

### supportsMixedCaseIdentifiers

    public boolean supportsMixedCaseIdentifiers()
                                         throws SQLException

  Does the database treat mixed case unquoted SQL identifiers as case sensitive and as a result store them in mixed case? A JDBC CompliantTM driver will always return false.

  Specified by:
    `supportsMixedCaseIdentifiers` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsStatementPooling

    public boolean supportsStatementPooling()
                                     throws SQLException

  Specified by:
    `supportsStatementPooling` in interface `DatabaseMetaData`
  Returns:
    a `boolean` value
  Throws:
    `SQLException` - if an error occurs TODO implement statemet pooling on the server.. then in the driver

### locatorsUpdateCopy

    public boolean locatorsUpdateCopy()
                               throws SQLException

  Describe `locatorsUpdateCopy` method here.

  Specified by:
    `locatorsUpdateCopy` in interface `DatabaseMetaData`
  Returns:
    a `boolean` value
  Throws:
    `SQLException` - if an error occurs TODO find out what this even means

### storesUpperCaseIdentifiers

    public boolean storesUpperCaseIdentifiers()
                                       throws SQLException

  Does the database treat mixed case unquoted SQL identifiers as case insensitive and store them in upper case?

  Specified by:
    `storesUpperCaseIdentifiers` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### storesLowerCaseIdentifiers

    public boolean storesLowerCaseIdentifiers()
                                       throws SQLException

  Does the database treat mixed case unquoted SQL identifiers as case insensitive and store them in lower case?

  Specified by:
    `storesLowerCaseIdentifiers` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### storesMixedCaseIdentifiers

    public boolean storesMixedCaseIdentifiers()
                                       throws SQLException

  Does the database treat mixed case unquoted SQL identifiers as case insensitive and store them in mixed case?

  Specified by:
    `storesMixedCaseIdentifiers` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsMixedCaseQuotedIdentifiers

    public boolean supportsMixedCaseQuotedIdentifiers()
                                               throws SQLException

  Does the database treat mixed case quoted SQL identifiers as case sensitive and as a result store them in mixed case? A JDBC CompliantTM driver will always return true.

  Specified by:
    `supportsMixedCaseQuotedIdentifiers` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### storesUpperCaseQuotedIdentifiers

    public boolean storesUpperCaseQuotedIdentifiers()
                                             throws SQLException

  Does the database treat mixed case quoted SQL identifiers as case insensitive and store them in upper case?

  Specified by:
    `storesUpperCaseQuotedIdentifiers` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### storesLowerCaseQuotedIdentifiers

    public boolean storesLowerCaseQuotedIdentifiers()
                                             throws SQLException

  Does the database treat mixed case quoted SQL identifiers as case insensitive and store them in lower case?

  Specified by:
    `storesLowerCaseQuotedIdentifiers` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### storesMixedCaseQuotedIdentifiers

    public boolean storesMixedCaseQuotedIdentifiers()
                                             throws SQLException

  Does the database treat mixed case quoted SQL identifiers as case insensitive and store them in mixed case?

  Specified by:
    `storesMixedCaseQuotedIdentifiers` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### getIdentifierQuoteString

    public String getIdentifierQuoteString()
                                    throws SQLException

  What's the string used to quote SQL identifiers? This returns a space " " if identifier quoting isn't supported. A JDBC CompliantTM driver always uses a double quote character.

  Specified by:
    `getIdentifierQuoteString` in interface `DatabaseMetaData`
  Returns:
    the quoting string
  Throws:
    `SQLException` - if a database access error occurs

### getSQLKeywords

    public String getSQLKeywords()
                          throws SQLException

  Gets a comma-separated list of all a database's SQL keywords that are NOT also SQL92 keywords.

  Specified by:
    `getSQLKeywords` in interface `DatabaseMetaData`
  Returns:
    the list
  Throws:
    `SQLException` - if a database access error occurs

### getNumericFunctions

    public String getNumericFunctions()
                               throws SQLException

  Gets a comma-separated list of math functions. These are the X/Open CLI math function names used in the JDBC function escape clause.

  Specified by:
    `getNumericFunctions` in interface `DatabaseMetaData`
  Returns:
    the list
  Throws:
    `SQLException` - if a database access error occurs

### getStringFunctions

    public String getStringFunctions()
                              throws SQLException

  Gets a comma-separated list of string functions. These are the X/Open CLI string function names used in the JDBC function escape clause.

  Specified by:
    `getStringFunctions` in interface `DatabaseMetaData`
  Returns:
    the list
  Throws:
    `SQLException` - if a database access error occurs

### getSystemFunctions

    public String getSystemFunctions()
                              throws SQLException

  Gets a comma-separated list of system functions. These are the X/Open CLI system function names used in the JDBC function escape clause.

  Specified by:
    `getSystemFunctions` in interface `DatabaseMetaData`
  Returns:
    the list
  Throws:
    `SQLException` - if a database access error occurs

### getTimeDateFunctions

    public String getTimeDateFunctions()
                                throws SQLException

  Gets a comma-separated list of time and date functions.

  Specified by:
    `getTimeDateFunctions` in interface `DatabaseMetaData`
  Returns:
    the list
  Throws:
    `SQLException` - if a database access error occurs

### getSearchStringEscape

    public String getSearchStringEscape()
                                 throws SQLException

  Gets the string that can be used to escape wildcard characters. This is the string that can be used to escape '_' or '%' in the string pattern style catalog search parameters.

  The '_' character represents any single character.

  The '%' character represents any sequence of zero or more characters.

  Specified by:
    `getSearchStringEscape` in interface `DatabaseMetaData`
  Returns:
    the string used to escape wildcard characters
  Throws:
    `SQLException` - if a database access error occurs

### getExtraNameCharacters

    public String getExtraNameCharacters()
                                  throws SQLException

  Gets all the "extra" characters that can be used in unquoted identifier names (those beyond a-z, A-Z, 0-9 and _).

  Specified by:
    `getExtraNameCharacters` in interface `DatabaseMetaData`
  Returns:
    the string containing the extra characters
  Throws:
    `SQLException` - if a database access error occurs

### supportsAlterTableWithAddColumn

    public boolean supportsAlterTableWithAddColumn()
                                            throws SQLException

  Is "ALTER TABLE" with add column supported?

  Specified by:
    `supportsAlterTableWithAddColumn` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsAlterTableWithDropColumn

    public boolean supportsAlterTableWithDropColumn()
                                             throws SQLException

  Is "ALTER TABLE" with drop column supported?

  Specified by:
    `supportsAlterTableWithDropColumn` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsColumnAliasing

    public boolean supportsColumnAliasing()
                                   throws SQLException

  Is column aliasing supported?

  If so, the SQL AS clause can be used to provide names for computed columns or to provide alias names for columns as required. A JDBC CompliantTM driver always returns true.

  Specified by:
    `supportsColumnAliasing` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### nullPlusNonNullIsNull

    public boolean nullPlusNonNullIsNull()
                                  throws SQLException

  Retrieves whether concatenations between NULL and non-NULL values equal NULL. For SQL-92 compliance, a JDBC technology-enabled driver will return `true`.

  Specified by:
    `nullPlusNonNullIsNull` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsConvert

    public boolean supportsConvert()
                            throws SQLException

  Is the CONVERT function between SQL types supported? What is this??? my sql ref says CONVERT is a string encoding map!

  Specified by:
    `supportsConvert` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsConvert

    public boolean supportsConvert(int fromType,
                                   int toType)
                            throws SQLException

  Retrieves whether CONVERT between the given SQL types supported.

  Specified by:
    `supportsConvert` in interface `DatabaseMetaData`
  Parameters:
    `fromType` - the type to convert from
    `toType` - the type to convert to
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `Types`

### supportsTableCorrelationNames

    public boolean supportsTableCorrelationNames()
                                          throws SQLException

  Are table correlation names supported? A JDBC CompliantTM driver always returns true.

  Specified by:
    `supportsTableCorrelationNames` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsDifferentTableCorrelationNames

    public boolean supportsDifferentTableCorrelationNames()
                                                   throws SQLException

  If table correlation names are supported, are they restricted to be different from the names of the tables?

  Specified by:
    `supportsDifferentTableCorrelationNames` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsExpressionsInOrderBy

    public boolean supportsExpressionsInOrderBy()
                                         throws SQLException

  Are expressions in "ORDER BY" lists supported?

  Specified by:
    `supportsExpressionsInOrderBy` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsOrderByUnrelated

    public boolean supportsOrderByUnrelated()
                                     throws SQLException

  Can an "ORDER BY" clause use columns not in the SELECT statement?

  Specified by:
    `supportsOrderByUnrelated` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsGroupBy

    public boolean supportsGroupBy()
                            throws SQLException

  Is some form of "GROUP BY" clause supported?

  Specified by:
    `supportsGroupBy` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsGroupByUnrelated

    public boolean supportsGroupByUnrelated()
                                     throws SQLException

  Can a "GROUP BY" clause use columns not in the SELECT?

  Specified by:
    `supportsGroupByUnrelated` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsGroupByBeyondSelect

    public boolean supportsGroupByBeyondSelect()
                                        throws SQLException

  Can a "GROUP BY" clause add columns not in the SELECT provided it specifies all the columns in the SELECT?

  Specified by:
    `supportsGroupByBeyondSelect` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsLikeEscapeClause

    public boolean supportsLikeEscapeClause()
                                     throws SQLException

  Is the escape character in "LIKE" clauses supported? A JDBC CompliantTM driver always returns true.

  Specified by:
    `supportsLikeEscapeClause` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsMultipleResultSets

    public boolean supportsMultipleResultSets()
                                       throws SQLException

  Are multiple `ResultSet` from a single execute supported?

  Specified by:
    `supportsMultipleResultSets` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsMultipleTransactions

    public boolean supportsMultipleTransactions()
                                         throws SQLException

  Can we have multiple transactions open at once (on different connections)?

  Specified by:
    `supportsMultipleTransactions` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsNonNullableColumns

    public boolean supportsNonNullableColumns()
                                       throws SQLException

  Can columns be defined as non-nullable? A JDBC CompliantTM driver always returns true.

  Specified by:
    `supportsNonNullableColumns` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsMinimumSQLGrammar

    public boolean supportsMinimumSQLGrammar()
                                      throws SQLException

  Is the ODBC Minimum SQL grammar supported? All JDBC CompliantTM drivers must return true.

  Specified by:
    `supportsMinimumSQLGrammar` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsCoreSQLGrammar

    public boolean supportsCoreSQLGrammar()
                                   throws SQLException

  Is the ODBC Core SQL grammar supported?

  Specified by:
    `supportsCoreSQLGrammar` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsExtendedSQLGrammar

    public boolean supportsExtendedSQLGrammar()
                                       throws SQLException

  Is the ODBC Extended SQL grammar supported?

  Specified by:
    `supportsExtendedSQLGrammar` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsANSI92EntryLevelSQL

    public boolean supportsANSI92EntryLevelSQL()
                                        throws SQLException

  Is the ANSI92 entry level SQL grammar supported? All JDBC CompliantTM drivers must return true.

  Specified by:
    `supportsANSI92EntryLevelSQL` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsANSI92IntermediateSQL

    public boolean supportsANSI92IntermediateSQL()
                                          throws SQLException

  Is the ANSI92 intermediate SQL grammar supported?

  Specified by:
    `supportsANSI92IntermediateSQL` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsANSI92FullSQL

    public boolean supportsANSI92FullSQL()
                                  throws SQLException

  Is the ANSI92 full SQL grammar supported?

  Specified by:
    `supportsANSI92FullSQL` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsIntegrityEnhancementFacility

    public boolean supportsIntegrityEnhancementFacility()
                                                 throws SQLException

  Is the SQL Integrity Enhancement Facility supported?

  Specified by:
    `supportsIntegrityEnhancementFacility` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsOuterJoins

    public boolean supportsOuterJoins()
                               throws SQLException

  Is some form of outer join supported?

  Specified by:
    `supportsOuterJoins` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsFullOuterJoins

    public boolean supportsFullOuterJoins()
                                   throws SQLException

  Are full nested outer joins supported?

  Specified by:
    `supportsFullOuterJoins` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsLimitedOuterJoins

    public boolean supportsLimitedOuterJoins()
                                      throws SQLException

  Is there limited support for outer joins? (This will be true if supportFullOuterJoins is true.)

  Specified by:
    `supportsLimitedOuterJoins` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### getSchemaTerm

    public String getSchemaTerm()
                         throws SQLException

  What's the database vendor's preferred term for "schema"?

  Specified by:
    `getSchemaTerm` in interface `DatabaseMetaData`
  Returns:
    the vendor term, always `null` because schemas are not supported by database server (see JDBC CTS for details).
  Throws:
    `SQLException` - if a database access error occurs

### getProcedureTerm

    public String getProcedureTerm()
                            throws SQLException

  What's the database vendor's preferred term for "procedure"?

  Specified by:
    `getProcedureTerm` in interface `DatabaseMetaData`
  Returns:
    the vendor term
  Throws:
    `SQLException` - if a database access error occurs

### getCatalogTerm

    public String getCatalogTerm()
                          throws SQLException

  What's the database vendor's preferred term for "catalog"?

  Specified by:
    `getCatalogTerm` in interface `DatabaseMetaData`
  Returns:
    the vendor term, always `null` because catalogs are not supported by database server (see JDBC CTS for details).
  Throws:
    `SQLException` - if a database access error occurs

### isCatalogAtStart

    public boolean isCatalogAtStart()
                             throws SQLException

  Does a catalog appear at the start of a qualified table name? (Otherwise it appears at the end)

  Specified by:
    `isCatalogAtStart` in interface `DatabaseMetaData`
  Returns:
    true if it appears at the start
  Throws:
    `SQLException` - if a database access error occurs

### getCatalogSeparator

    public String getCatalogSeparator()
                               throws SQLException

  What's the separator between catalog and table name?

  Specified by:
    `getCatalogSeparator` in interface `DatabaseMetaData`
  Returns:
    the separator string, always `null` because catalogs are not supported by database server (see JDBC CTS for details).
  Throws:
    `SQLException` - if a database access error occurs

### supportsSchemasInDataManipulation

    public boolean supportsSchemasInDataManipulation()
                                              throws SQLException

  Can a schema name be used in a data manipulation statement?

  Specified by:
    `supportsSchemasInDataManipulation` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsSchemasInProcedureCalls

    public boolean supportsSchemasInProcedureCalls()
                                            throws SQLException

  Can a schema name be used in a procedure call statement?

  Specified by:
    `supportsSchemasInProcedureCalls` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsSchemasInTableDefinitions

    public boolean supportsSchemasInTableDefinitions()
                                              throws SQLException

  Can a schema name be used in a table definition statement?

  Specified by:
    `supportsSchemasInTableDefinitions` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsSchemasInIndexDefinitions

    public boolean supportsSchemasInIndexDefinitions()
                                              throws SQLException

  Can a schema name be used in an index definition statement?

  Specified by:
    `supportsSchemasInIndexDefinitions` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsSchemasInPrivilegeDefinitions

    public boolean supportsSchemasInPrivilegeDefinitions()
                                                  throws SQLException

  Can a schema name be used in a privilege definition statement?

  Specified by:
    `supportsSchemasInPrivilegeDefinitions` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsCatalogsInDataManipulation

    public boolean supportsCatalogsInDataManipulation()
                                               throws SQLException

  Can a catalog name be used in a data manipulation statement?

  Specified by:
    `supportsCatalogsInDataManipulation` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsCatalogsInProcedureCalls

    public boolean supportsCatalogsInProcedureCalls()
                                             throws SQLException

  Can a catalog name be used in a procedure call statement?

  Specified by:
    `supportsCatalogsInProcedureCalls` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsCatalogsInTableDefinitions

    public boolean supportsCatalogsInTableDefinitions()
                                               throws SQLException

  Can a catalog name be used in a table definition statement?

  Specified by:
    `supportsCatalogsInTableDefinitions` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsCatalogsInIndexDefinitions

    public boolean supportsCatalogsInIndexDefinitions()
                                               throws SQLException

  Can a catalog name be used in an index definition statement?

  Specified by:
    `supportsCatalogsInIndexDefinitions` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsCatalogsInPrivilegeDefinitions

    public boolean supportsCatalogsInPrivilegeDefinitions()
                                                   throws SQLException

  Can a catalog name be used in a privilege definition statement?

  Specified by:
    `supportsCatalogsInPrivilegeDefinitions` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsPositionedDelete

    public boolean supportsPositionedDelete()
                                     throws SQLException

  Is positioned DELETE supported?

  Specified by:
    `supportsPositionedDelete` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsPositionedUpdate

    public boolean supportsPositionedUpdate()
                                     throws SQLException

  Is positioned UPDATE supported?

  Specified by:
    `supportsPositionedUpdate` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsSelectForUpdate

    public boolean supportsSelectForUpdate()
                                    throws SQLException

  Is SELECT for UPDATE supported?

  Specified by:
    `supportsSelectForUpdate` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsStoredProcedures

    public boolean supportsStoredProcedures()
                                     throws SQLException

  Are stored procedure calls using the stored procedure escape syntax supported?

  Specified by:
    `supportsStoredProcedures` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsSubqueriesInComparisons

    public boolean supportsSubqueriesInComparisons()
                                            throws SQLException

  Are subqueries in comparison expressions supported? A JDBC CompliantTM driver always returns true.

  Specified by:
    `supportsSubqueriesInComparisons` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsSubqueriesInExists

    public boolean supportsSubqueriesInExists()
                                       throws SQLException

  Are subqueries in 'exists' expressions supported? A JDBC CompliantTM driver always returns true.

  Specified by:
    `supportsSubqueriesInExists` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsSubqueriesInIns

    public boolean supportsSubqueriesInIns()
                                    throws SQLException

  Are subqueries in 'in' statements supported? A JDBC CompliantTM driver always returns true.

  Specified by:
    `supportsSubqueriesInIns` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsSubqueriesInQuantifieds

    public boolean supportsSubqueriesInQuantifieds()
                                            throws SQLException

  Are subqueries in quantified expressions supported? A JDBC CompliantTM driver always returns true.

  Specified by:
    `supportsSubqueriesInQuantifieds` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsCorrelatedSubqueries

    public boolean supportsCorrelatedSubqueries()
                                         throws SQLException

  Are correlated subqueries supported? A JDBC CompliantTM driver always returns true.

  Specified by:
    `supportsCorrelatedSubqueries` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsUnion

    public boolean supportsUnion()
                          throws SQLException

  Is SQL UNION supported?

  Specified by:
    `supportsUnion` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsUnionAll

    public boolean supportsUnionAll()
                             throws SQLException

  Is SQL UNION ALL supported?

  Specified by:
    `supportsUnionAll` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsOpenCursorsAcrossCommit

    public boolean supportsOpenCursorsAcrossCommit()
                                            throws SQLException

  Can cursors remain open across commits?

  Specified by:
    `supportsOpenCursorsAcrossCommit` in interface `DatabaseMetaData`
  Returns:
    `true` if cursors always remain open; `false` if they might not remain open
  Throws:
    `SQLException` - if a database access error occurs

### supportsOpenCursorsAcrossRollback

    public boolean supportsOpenCursorsAcrossRollback()
                                              throws SQLException

  Can cursors remain open across rollbacks?

  Specified by:
    `supportsOpenCursorsAcrossRollback` in interface `DatabaseMetaData`
  Returns:
    `true` if cursors always remain open; `false` if they might not remain open
  Throws:
    `SQLException` - if a database access error occurs

### supportsOpenStatementsAcrossCommit

    public boolean supportsOpenStatementsAcrossCommit()
                                               throws SQLException

  Can statements remain open across commits?

  Specified by:
    `supportsOpenStatementsAcrossCommit` in interface `DatabaseMetaData`
  Returns:
    `true` if statements always remain open; `false` if they might not remain open
  Throws:
    `SQLException` - if a database access error occurs

### supportsOpenStatementsAcrossRollback

    public boolean supportsOpenStatementsAcrossRollback()
                                                 throws SQLException

  Can statements remain open across rollbacks?

  Specified by:
    `supportsOpenStatementsAcrossRollback` in interface `DatabaseMetaData`
  Returns:
    `true` if statements always remain open; `false` if they might not remain open
  Throws:
    `SQLException` - if a database access error occurs

### getMaxBinaryLiteralLength

    public int getMaxBinaryLiteralLength()
                                  throws SQLException

  How many hex characters can you have in an inline binary literal?

  Specified by:
    `getMaxBinaryLiteralLength` in interface `DatabaseMetaData`
  Returns:
    max binary literal length in hex characters; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getMaxCharLiteralLength

    public int getMaxCharLiteralLength()
                                throws SQLException

  What's the max length for a character literal?

  Specified by:
    `getMaxCharLiteralLength` in interface `DatabaseMetaData`
  Returns:
    max literal length; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getMaxColumnNameLength

    public int getMaxColumnNameLength()
                               throws SQLException

  What's the limit on column name length?

  Specified by:
    `getMaxColumnNameLength` in interface `DatabaseMetaData`
  Returns:
    max column name length; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getMaxColumnsInGroupBy

    public int getMaxColumnsInGroupBy()
                               throws SQLException

  What's the maximum number of columns in a "GROUP BY" clause?

  Specified by:
    `getMaxColumnsInGroupBy` in interface `DatabaseMetaData`
  Returns:
    max number of columns; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getMaxColumnsInIndex

    public int getMaxColumnsInIndex()
                             throws SQLException

  What's the maximum number of columns allowed in an index?

  Specified by:
    `getMaxColumnsInIndex` in interface `DatabaseMetaData`
  Returns:
    max number of columns; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getMaxColumnsInOrderBy

    public int getMaxColumnsInOrderBy()
                               throws SQLException

  What's the maximum number of columns in an "ORDER BY" clause?

  Specified by:
    `getMaxColumnsInOrderBy` in interface `DatabaseMetaData`
  Returns:
    max number of columns; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getMaxColumnsInSelect

    public int getMaxColumnsInSelect()
                              throws SQLException

  What's the maximum number of columns in a "SELECT" list?

  Specified by:
    `getMaxColumnsInSelect` in interface `DatabaseMetaData`
  Returns:
    max number of columns; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getMaxColumnsInTable

    public int getMaxColumnsInTable()
                             throws SQLException

  What's the maximum number of columns in a table?

  Specified by:
    `getMaxColumnsInTable` in interface `DatabaseMetaData`
  Returns:
    max number of columns; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getMaxConnections

    public int getMaxConnections()
                          throws SQLException

  How many active connections can we have at a time to this database?

  Specified by:
    `getMaxConnections` in interface `DatabaseMetaData`
  Returns:
    max number of active connections; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getMaxCursorNameLength

    public int getMaxCursorNameLength()
                               throws SQLException

  What's the maximum cursor name length?

  Specified by:
    `getMaxCursorNameLength` in interface `DatabaseMetaData`
  Returns:
    max cursor name length in bytes; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getMaxIndexLength

    public int getMaxIndexLength()
                          throws SQLException

  Retrieves the maximum number of bytes for an index, including all of the parts of the index.

  Specified by:
    `getMaxIndexLength` in interface `DatabaseMetaData`
  Returns:
    max index length in bytes, which includes the composite of all the constituent parts of the index; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getMaxSchemaNameLength

    public int getMaxSchemaNameLength()
                               throws SQLException

  What's the maximum length allowed for a schema name?

  Specified by:
    `getMaxSchemaNameLength` in interface `DatabaseMetaData`
  Returns:
    max name length in bytes; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getMaxProcedureNameLength

    public int getMaxProcedureNameLength()
                                  throws SQLException

  What's the maximum length of a procedure name?

  Specified by:
    `getMaxProcedureNameLength` in interface `DatabaseMetaData`
  Returns:
    max name length in bytes; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getMaxCatalogNameLength

    public int getMaxCatalogNameLength()
                                throws SQLException

  What's the maximum length of a catalog name?

  Specified by:
    `getMaxCatalogNameLength` in interface `DatabaseMetaData`
  Returns:
    max name length in bytes; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getMaxRowSize

    public int getMaxRowSize()
                      throws SQLException

  What's the maximum length of a single row?

  Specified by:
    `getMaxRowSize` in interface `DatabaseMetaData`
  Returns:
    max row size in bytes; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### doesMaxRowSizeIncludeBlobs

    public boolean doesMaxRowSizeIncludeBlobs()
                                       throws SQLException

  Did getMaxRowSize() include LONGVARCHAR and LONGVARBINARY blobs?

  Specified by:
    `doesMaxRowSizeIncludeBlobs` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### getMaxStatementLength

    public int getMaxStatementLength()
                              throws SQLException

  What's the maximum length of an SQL statement?

  Specified by:
    `getMaxStatementLength` in interface `DatabaseMetaData`
  Returns:
    max length in bytes; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getMaxStatements

    public int getMaxStatements()
                         throws SQLException

  How many active statements can we have open at one time to this database?

  Specified by:
    `getMaxStatements` in interface `DatabaseMetaData`
  Returns:
    the maximum number of statements that can be open at one time; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getMaxTableNameLength

    public int getMaxTableNameLength()
                              throws SQLException

  What's the maximum length of a table name?

  Specified by:
    `getMaxTableNameLength` in interface `DatabaseMetaData`
  Returns:
    max name length in bytes; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getMaxTablesInSelect

    public int getMaxTablesInSelect()
                             throws SQLException

  What's the maximum number of tables in a SELECT statement?

  Specified by:
    `getMaxTablesInSelect` in interface `DatabaseMetaData`
  Returns:
    the maximum number of tables allowed in a SELECT statement; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getMaxUserNameLength

    public int getMaxUserNameLength()
                             throws SQLException

  What's the maximum length of a user name?

  Specified by:
    `getMaxUserNameLength` in interface `DatabaseMetaData`
  Returns:
    max user name length in bytes; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getDefaultTransactionIsolation

    public int getDefaultTransactionIsolation()
                                       throws SQLException

  What's the database's default transaction isolation level? The values are defined in `java.sql.Connection`.

  Specified by:
    `getDefaultTransactionIsolation` in interface `DatabaseMetaData`
  Returns:
    the default isolation level
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `Connection`

### supportsTransactions

    public boolean supportsTransactions()
                                 throws SQLException

  Are transactions supported? If not, invoking the method `commit` is a noop and the isolation level is TRANSACTION_NONE.

  Specified by:
    `supportsTransactions` in interface `DatabaseMetaData`
  Returns:
    `true` if transactions are supported; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsTransactionIsolationLevel

    public boolean supportsTransactionIsolationLevel(int level)
                                              throws SQLException

  Does this database support the given transaction isolation level?

  Specified by:
    `supportsTransactionIsolationLevel` in interface `DatabaseMetaData`
  Parameters:
    `level` - the values are defined in `java.sql.Connection`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `Connection`

### supportsDataDefinitionAndDataManipulationTransactions

    public boolean supportsDataDefinitionAndDataManipulationTransactions()
                                                                  throws SQLException

  Are both data definition and data manipulation statements within a transaction supported?

  Specified by:
    `supportsDataDefinitionAndDataManipulationTransactions` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsDataManipulationTransactionsOnly

    public boolean supportsDataManipulationTransactionsOnly()
                                                     throws SQLException

  Are only data manipulation statements within a transaction supported?

  Specified by:
    `supportsDataManipulationTransactionsOnly` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### dataDefinitionCausesTransactionCommit

    public boolean dataDefinitionCausesTransactionCommit()
                                                  throws SQLException

  Does a data definition statement within a transaction force the transaction to commit?

  Specified by:
    `dataDefinitionCausesTransactionCommit` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### dataDefinitionIgnoredInTransactions

    public boolean dataDefinitionIgnoredInTransactions()
                                                throws SQLException

  Is a data definition statement within a transaction ignored?

  Specified by:
    `dataDefinitionIgnoredInTransactions` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### getProcedures

    public ResultSet getProcedures(String catalog,
                                   String schemaPattern,
                                   String procedureNamePattern)
                            throws SQLException

  Gets a description of the stored procedures available in a catalog.

  Only procedure descriptions matching the schema and procedure name criteria are returned. They are ordered by PROCEDURE_SCHEM, and PROCEDURE_NAME.

  Each procedure description has the the following columns:

  1. PROCEDURE_CAT String => procedure catalog (may be null)
  2. PROCEDURE_SCHEM String => procedure schema (may be null)
  3. PROCEDURE_NAME String => procedure name
  4. reserved for future use
  5. reserved for future use
  6. reserved for future use
  7. REMARKS String => explanatory comment on the procedure
  8. PROCEDURE_TYPE short => kind of procedure:
     - procedureResultUnknown - May return a result
     - procedureNoResult - Does not return a result
     - procedureReturnsResult - Returns a result

  Specified by:
    `getProcedures` in interface `DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    `schemaPattern` - a schema name pattern; "" retrieves those without a schema
    `procedureNamePattern` - a procedure name pattern
  Returns:
    `ResultSet` - each row is a procedure description
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `getSearchStringEscape()`

### getProcedureColumns

    public ResultSet getProcedureColumns(String catalog,
                                         String schemaPattern,
                                         String procedureNamePattern,
                                         String columnNamePattern)
                                  throws SQLException

  Gets a description of a catalog's stored procedure parameters and result columns.

  Only descriptions matching the schema, procedure and parameter name criteria are returned. They are ordered by PROCEDURE_SCHEM and PROCEDURE_NAME. Within this, the return value, if any, is first. Next are the parameter descriptions in call order. The column descriptions follow in column number order.

  Each row in the `ResultSet` is a parameter description or column description with the following fields:

  1. PROCEDURE_CAT String => procedure catalog (may be null)
  2. PROCEDURE_SCHEM String => procedure schema (may be null)
  3. PROCEDURE_NAME String => procedure name
  4. COLUMN_NAME String => column/parameter name
  5. COLUMN_TYPE Short => kind of column/parameter:
     - procedureColumnUnknown - nobody knows
     - procedureColumnIn - IN parameter
     - procedureColumnInOut - INOUT parameter
     - procedureColumnOut - OUT parameter
     - procedureColumnReturn - procedure return value
     - procedureColumnResult - result column in `ResultSet`
  6. DATA_TYPE short => SQL type from java.sql.Types
  7. TYPE_NAME String => SQL type name, for a UDT type the type name is fully qualified
  8. PRECISION int => precision
  9. LENGTH int => length in bytes of data
  10. SCALE short => scale
  11. RADIX short => radix
  12. NULLABLE short => can it contain NULL?
      - procedureNoNulls - does not allow NULL values
      - procedureNullable - allows NULL values
      - procedureNullableUnknown - nullability unknown
  13. REMARKS String => comment describing parameter/column

  Note: Some databases may not return the column descriptions for a procedure. Additional columns beyond REMARKS can be defined by the database.

  Specified by:
    `getProcedureColumns` in interface `DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    `schemaPattern` - a schema name pattern; "" retrieves those without a schema
    `procedureNamePattern` - a procedure name pattern
    `columnNamePattern` - a column name pattern
  Returns:
    `ResultSet` - each row describes a stored procedure parameter or column
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `getSearchStringEscape()`

### getTables

    public ResultSet getTables(String catalog,
                               String schemaPattern,
                               String tableNamePattern,
                               String[] types)
                        throws SQLException

  Gets a description of tables available in a catalog.

  Only table descriptions matching the catalog, schema, table name and type criteria are returned. They are ordered by TABLE_TYPE, TABLE_SCHEM and TABLE_NAME.

  Each table description has the following columns:

  1. TABLE_CAT String => table catalog (may be null)
  2. TABLE_SCHEM String => table schema (may be null)
  3. TABLE_NAME String => table name
  4. TABLE_TYPE String => table type. Typical types are "TABLE", "VIEW", "SYSTEM TABLE", "GLOBAL TEMPORARY", "LOCAL TEMPORARY", "ALIAS", "SYNONYM".
  5. REMARKS String => explanatory comment on the table

  Note: Some databases may not return information for all tables.

  Specified by:
    `getTables` in interface `DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    `schemaPattern` - a schema name pattern; "" retrieves those without a schema
    `tableNamePattern` - a table name pattern
    `types` - a list of table types to include; null returns all types
  Returns:
    `ResultSet` - each row is a table description
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `getSearchStringEscape()`

### getSchemas

    public ResultSet getSchemas()
                         throws SQLException

  Gets the schema names available in this database. The results are ordered by schema name.

  The schema column is:

  1. TABLE_SCHEM String => schema name

  Specified by:
    `getSchemas` in interface `DatabaseMetaData`
  Returns:
    `ResultSet` - each row has a single String column that is a schema name
  Throws:
    `SQLException` - if a database access error occurs

### getCatalogs

    public ResultSet getCatalogs()
                          throws SQLException

  Gets the catalog names available in this database. The results are ordered by catalog name.

  The catalog column is:

  1. TABLE_CAT String => catalog name

  Specified by:
    `getCatalogs` in interface `DatabaseMetaData`
  Returns:
    `ResultSet` - each row has a single String column that is a catalog name
  Throws:
    `SQLException` - if a database access error occurs

### getTableTypes

    public ResultSet getTableTypes()
                            throws SQLException

  Gets the table types available in this database. The results are ordered by table type.

  The table type is:

  1. TABLE_TYPE String => table type. Typical types are "TABLE", "VIEW", "SYSTEM TABLE", "GLOBAL TEMPORARY", "LOCAL TEMPORARY", "ALIAS", "SYNONYM".

  Specified by:
    `getTableTypes` in interface `DatabaseMetaData`
  Returns:
    `ResultSet` - each row has a single String column that is a table type
  Throws:
    `SQLException` - if a database access error occurs

### getColumns

    public ResultSet getColumns(String catalog,
                                String schemaPattern,
                                String tableNamePattern,
                                String columnNamePattern)
                         throws SQLException

  Gets a description of table columns available in the specified catalog.

  Only column descriptions matching the catalog, schema, table and column name criteria are returned. They are ordered by TABLE_SCHEM, TABLE_NAME and ORDINAL_POSITION.

  Each column description has the following columns:

  1. TABLE_CAT String => table catalog (may be null)
  2. TABLE_SCHEM String => table schema (may be null)
  3. TABLE_NAME String => table name
  4. COLUMN_NAME String => column name
  5. DATA_TYPE short => SQL type from java.sql.Types
  6. TYPE_NAME String => Data source dependent type name, for a UDT the type name is fully qualified
  7. COLUMN_SIZE int => column size. For char or date types this is the maximum number of characters, for numeric or decimal types this is precision.
  8. BUFFER_LENGTH is not used.
  9. DECIMAL_DIGITS int => the number of fractional digits
  10. NUM_PREC_RADIX int => Radix (typically either 10 or 2)
  11. NULLABLE int => is NULL allowed?
      - columnNoNulls - might not allow NULL values
      - columnNullable - definitely allows NULL values
      - columnNullableUnknown - nullability unknown
  12. REMARKS String => comment describing column (may be null)
  13. COLUMN_DEF String => default value (may be null)
  14. SQL_DATA_TYPE int => unused
  15. SQL_DATETIME_SUB int => unused
  16. CHAR_OCTET_LENGTH int => for char types the
  17. CHAR_OCTET_LENGTH int => for char types the maximum number of bytes in the column
  18. ORDINAL_POSITION int => index of column in table (starting at 1)
  19. IS_NULLABLE String => "NO" means column definitely does not allow NULL values; "YES" means the column might allow NULL values. An empty string means nobody knows.

  Specified by:
    `getColumns` in interface `DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    `schemaPattern` - a schema name pattern; "" retrieves those without a schema
    `tableNamePattern` - a table name pattern
    `columnNamePattern` - a column name pattern
  Returns:
    `ResultSet` - each row is a column description
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `getSearchStringEscape()`

### getColumnPrivileges

    public ResultSet getColumnPrivileges(String catalog,
                                         String schema,
                                         String table,
                                         String columnNamePattern)
                                  throws SQLException

  Gets a description of the access rights for a table's columns.

  Only privileges matching the column name criteria are returned. They are ordered by COLUMN_NAME and PRIVILEGE.

  Each privilige description has the following columns:

  1. TABLE_CAT String => table catalog (may be null)
  2. TABLE_SCHEM String => table schema (may be null)
  3. TABLE_NAME String => table name
  4. COLUMN_NAME String => column name
  5. GRANTOR => grantor of access (may be null)
  6. GRANTEE String => grantee of access
  7. PRIVILEGE String => name of access (SELECT, INSERT, UPDATE, REFRENCES, ...)
  8. IS_GRANTABLE String => "YES" if grantee is permitted to grant to others; "NO" if not; null if unknown

  Specified by:
    `getColumnPrivileges` in interface `DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    `schema` - a schema name; "" retrieves those without a schema
    `table` - a table name
    `columnNamePattern` - a column name pattern
  Returns:
    `ResultSet` - each row is a column privilege description
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `getSearchStringEscape()`

### getTablePrivileges

    public ResultSet getTablePrivileges(String catalog,
                                        String schemaPattern,
                                        String tableNamePattern)
                                 throws SQLException

  Gets a description of the access rights for each table available in a catalog. Note that a table privilege applies to one or more columns in the table. It would be wrong to assume that this priviledge applies to all columns (this may be true for some systems but is not true for all.)

  Only privileges matching the schema and table name criteria are returned. They are ordered by TABLE_SCHEM, TABLE_NAME, and PRIVILEGE.

  Each privilige description has the following columns:

  1. TABLE_CAT String => table catalog (may be null)
  2. TABLE_SCHEM String => table schema (may be null)
  3. TABLE_NAME String => table name
  4. GRANTOR => grantor of access (may be null)
  5. GRANTEE String => grantee of access
  6. PRIVILEGE String => name of access (SELECT, INSERT, UPDATE, REFRENCES, ...)
  7. IS_GRANTABLE String => "YES" if grantee is permitted to grant to others; "NO" if not; null if unknown

  Specified by:
    `getTablePrivileges` in interface `DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    `schemaPattern` - a schema name pattern; "" retrieves those without a schema
    `tableNamePattern` - a table name pattern
  Returns:
    `ResultSet` - each row is a table privilege description
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `getSearchStringEscape()`

### getBestRowIdentifier

    public ResultSet getBestRowIdentifier(String catalog,
                                          String schema,
                                          String table,
                                          int scope,
                                          boolean nullable)
                                   throws SQLException

  Gets a description of a table's optimal set of columns that uniquely identifies a row. They are ordered by SCOPE.

  Each column description has the following columns:

  1. SCOPE short => actual scope of result
     - bestRowTemporary - very temporary, while using row
     - bestRowTransaction - valid for remainder of current transaction
     - bestRowSession - valid for remainder of current session
  2. COLUMN_NAME String => column name
  3. DATA_TYPE short => SQL data type from java.sql.Types
  4. TYPE_NAME String => Data source dependent type name, for a UDT the type name is fully qualified
  5. COLUMN_SIZE int => precision
  6. BUFFER_LENGTH int => not used
  7. DECIMAL_DIGITS short => scale
  8. PSEUDO_COLUMN short => is this a pseudo column like an Oracle ROWID
     - bestRowUnknown - may or may not be pseudo column
     - bestRowNotPseudo - is NOT a pseudo column
     - bestRowPseudo - is a pseudo column

  Specified by:
    `getBestRowIdentifier` in interface `DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    `schema` - a schema name; "" retrieves those without a schema
    `table` - a table name
    `scope` - the scope of interest; use same values as SCOPE
    `nullable` - include columns that are nullable?
  Returns:
    `ResultSet` - each row is a column description
  Throws:
    `SQLException` - if a database access error occurs

### getVersionColumns

    public ResultSet getVersionColumns(String catalog,
                                       String schema,
                                       String table)
                                throws SQLException

  Gets a description of a table's columns that are automatically updated when any value in a row is updated. They are unordered.

  Each column description has the following columns:

  1. SCOPE short => is not used
  2. COLUMN_NAME String => column name
  3. DATA_TYPE short => SQL data type from java.sql.Types
  4. TYPE_NAME String => Data source dependent type name
  5. COLUMN_SIZE int => precision
  6. BUFFER_LENGTH int => length of column value in bytes
  7. DECIMAL_DIGITS short => scale
  8. PSEUDO_COLUMN short => is this a pseudo column like an Oracle ROWID
     - versionColumnUnknown - may or may not be pseudo column
     - versionColumnNotPseudo - is NOT a pseudo column
     - versionColumnPseudo - is a pseudo column

  Specified by:
    `getVersionColumns` in interface `DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    `schema` - a schema name; "" retrieves those without a schema
    `table` - a table name
  Returns:
    `ResultSet` - each row is a column description
  Throws:
    `SQLException` - if a database access error occurs

### getPrimaryKeys

    public ResultSet getPrimaryKeys(String catalog,
                                    String schema,
                                    String table)
                             throws SQLException

  Gets a description of a table's primary key columns. They are ordered by COLUMN_NAME.

  Each primary key column description has the following columns:

  1. TABLE_CAT String => table catalog (may be null)
  2. TABLE_SCHEM String => table schema (may be null)
  3. TABLE_NAME String => table name
  4. COLUMN_NAME String => column name
  5. KEY_SEQ short => sequence number within primary key
  6. PK_NAME String => primary key name (may be null)

  Specified by:
    `getPrimaryKeys` in interface `DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    `schema` - a schema name; "" retrieves those without a schema
    `table` - a table name
  Returns:
    `ResultSet` - each row is a primary key column description
  Throws:
    `SQLException` - if a database access error occurs

### getImportedKeys

    public ResultSet getImportedKeys(String catalog,
                                     String schema,
                                     String table)
                              throws SQLException

  Gets a description of the primary key columns that are referenced by a table's foreign key columns (the primary keys imported by a table). They are ordered by PKTABLE_CAT, PKTABLE_SCHEM, PKTABLE_NAME, and KEY_SEQ.

  Each primary key column description has the following columns:

  1. PKTABLE_CAT String => primary key table catalog being imported (may be null)
  2. PKTABLE_SCHEM String => primary key table schema being imported (may be null)
  3. PKTABLE_NAME String => primary key table name being imported
  4. PKCOLUMN_NAME String => primary key column name being imported
  5. FKTABLE_CAT String => foreign key table catalog (may be null)
  6. FKTABLE_SCHEM String => foreign key table schema (may be null)
  7. FKTABLE_NAME String => foreign key table name
  8. FKCOLUMN_NAME String => foreign key column name
  9. KEY_SEQ short => sequence number within foreign key
  10. UPDATE_RULE short => What happens to foreign key when primary is updated:
      - importedNoAction - do not allow update of primary key if it has been imported
      - importedKeyCascade - change imported key to agree with primary key update
      - importedKeySetNull - change imported key to NULL if its primary key has been updated
      - importedKeySetDefault - change imported key to default values if its primary key has been updated
      - importedKeyRestrict - same as importedKeyNoAction (for ODBC 2.x compatibility)
  11. DELETE_RULE short => What happens to the foreign key when primary is deleted.
      - importedKeyNoAction - do not allow delete of primary key if it has been imported
      - importedKeyCascade - delete rows that import a deleted key
      - importedKeySetNull - change imported key to NULL if its primary key has been deleted
      - importedKeyRestrict - same as importedKeyNoAction (for ODBC 2.x compatibility)
      - importedKeySetDefault - change imported key to default if its primary key has been deleted
  12. FK_NAME String => foreign key name (may be null)
  13. PK_NAME String => primary key name (may be null)
  14. DEFERRABILITY short => can the evaluation of foreign key constraints be deferred until commit
      - importedKeyInitiallyDeferred - see SQL92 for definition
      - importedKeyInitiallyImmediate - see SQL92 for definition
      - importedKeyNotDeferrable - see SQL92 for definition

  Specified by:
    `getImportedKeys` in interface `DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    `schema` - a schema name; "" retrieves those without a schema
    `table` - a table name
  Returns:
    `ResultSet` - each row is a primary key column description
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `getExportedKeys(java.lang.String, java.lang.String, java.lang.String)`

### getExportedKeys

    public ResultSet getExportedKeys(String catalog,
                                     String schema,
                                     String table)
                              throws SQLException

  Gets a description of the foreign key columns that reference a table's primary key columns (the foreign keys exported by a table). They are ordered by FKTABLE_CAT, FKTABLE_SCHEM, FKTABLE_NAME, and KEY_SEQ.

  Each foreign key column description has the following columns:

  1. PKTABLE_CAT String => primary key table catalog (may be null)
  2. PKTABLE_SCHEM String => primary key table schema (may be null)
  3. PKTABLE_NAME String => primary key table name
  4. PKCOLUMN_NAME String => primary key column name
  5. FKTABLE_CAT String => foreign key table catalog (may be null) being exported (may be null)
  6. FKTABLE_SCHEM String => foreign key table schema (may be null) being exported (may be null)
  7. FKTABLE_NAME String => foreign key table name being exported
  8. FKCOLUMN_NAME String => foreign key column name being exported
  9. KEY_SEQ short => sequence number within foreign key
  10. UPDATE_RULE short => What happens to foreign key when primary is updated:
      - importedNoAction - do not allow update of primary key if it has been imported
      - importedKeyCascade - change imported key to agree with primary key update
      - importedKeySetNull - change imported key to NULL if its primary key has been updated
      - importedKeySetDefault - change imported key to default values if its primary key has been updated
      - importedKeyRestrict - same as importedKeyNoAction (for ODBC 2.x compatibility)
  11. DELETE_RULE short => What happens to the foreign key when primary is deleted.
      - importedKeyNoAction - do not allow delete of primary key if it has been imported
      - importedKeyCascade - delete rows that import a deleted key
      - importedKeySetNull - change imported key to NULL if its primary key has been deleted
      - importedKeyRestrict - same as importedKeyNoAction (for ODBC 2.x compatibility)
      - importedKeySetDefault - change imported key to default if its primary key has been deleted
  12. FK_NAME String => foreign key name (may be null)
  13. PK_NAME String => primary key name (may be null)
  14. DEFERRABILITY short => can the evaluation of foreign key constraints be deferred until commit
      - importedKeyInitiallyDeferred - see SQL92 for definition
      - importedKeyInitiallyImmediate - see SQL92 for definition
      - importedKeyNotDeferrable - see SQL92 for definition

  Specified by:
    `getExportedKeys` in interface `DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    `schema` - a schema name; "" retrieves those without a schema
    `table` - a table name
  Returns:
    `ResultSet` - each row is a foreign key column description
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `getImportedKeys(java.lang.String, java.lang.String, java.lang.String)`

### getCrossReference

    public ResultSet getCrossReference(String primaryCatalog,
                                       String primarySchema,
                                       String primaryTable,
                                       String foreignCatalog,
                                       String foreignSchema,
                                       String foreignTable)
                                throws SQLException

  Gets a description of the foreign key columns in the foreign key table that reference the primary key columns of the primary key table (describe how one table imports another's key). This should normally return a single foreign key/primary key pair (most tables only import a foreign key from a table once.) They are ordered by FKTABLE_CAT, FKTABLE_SCHEM, FKTABLE_NAME, and KEY_SEQ.

  Each foreign key column description has the following columns:

  1. PKTABLE_CAT String => primary key table catalog (may be null)
  2. PKTABLE_SCHEM String => primary key table schema (may be null)
  3. PKTABLE_NAME String => primary key table name
  4. PKCOLUMN_NAME String => primary key column name
  5. FKTABLE_CAT String => foreign key table catalog (may be null) being exported (may be null)
  6. FKTABLE_SCHEM String => foreign key table schema (may be null) being exported (may be null)
  7. FKTABLE_NAME String => foreign key table name being exported
  8. FKCOLUMN_NAME String => foreign key column name being exported
  9. KEY_SEQ short => sequence number within foreign key
  10. UPDATE_RULE short => What happens to foreign key when primary is updated:
      - importedNoAction - do not allow update of primary key if it has been imported
      - importedKeyCascade - change imported key to agree with primary key update
      - importedKeySetNull - change imported key to NULL if its primary key has been updated
      - importedKeySetDefault - change imported key to default values if its primary key has been updated
      - importedKeyRestrict - same as importedKeyNoAction (for ODBC 2.x compatibility)
  11. DELETE_RULE short => What happens to the foreign key when primary is deleted.
      - importedKeyNoAction - do not allow delete of primary key if it has been imported
      - importedKeyCascade - delete rows that import a deleted key
      - importedKeySetNull - change imported key to NULL if its primary key has been deleted
      - importedKeyRestrict - same as importedKeyNoAction (for ODBC 2.x compatibility)
      - importedKeySetDefault - change imported key to default if its primary key has been deleted
  12. FK_NAME String => foreign key name (may be null)
  13. PK_NAME String => primary key name (may be null)
  14. DEFERRABILITY short => can the evaluation of foreign key constraints be deferred until commit
      - importedKeyInitiallyDeferred - see SQL92 for definition
      - importedKeyInitiallyImmediate - see SQL92 for definition
      - importedKeyNotDeferrable - see SQL92 for definition

  Specified by:
    `getCrossReference` in interface `DatabaseMetaData`
  Parameters:
    `primaryCatalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    `primarySchema` - a schema name; "" retrieves those without a schema
    `primaryTable` - the table name that exports the key
    `foreignCatalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    `foreignSchema` - a schema name; "" retrieves those without a schema
    `foreignTable` - the table name that imports the key
  Returns:
    `ResultSet` - each row is a foreign key column description
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `getImportedKeys(java.lang.String, java.lang.String, java.lang.String)`

### getTypeInfo

    public ResultSet getTypeInfo()
                          throws SQLException

  Gets a description of all the standard SQL types supported by this database. They are ordered by DATA_TYPE and then by how closely the data type maps to the corresponding JDBC SQL type.

  Each type description has the following columns:

  1. TYPE_NAME String => Type name
  2. DATA_TYPE short => SQL data type from java.sql.Types
  3. PRECISION int => maximum precision
  4. LITERAL_PREFIX String => prefix used to quote a literal (may be null)
  5. LITERAL_SUFFIX String => suffix used to quote a literal (may be null)
  6. CREATE_PARAMS String => parameters used in creating the type (may be null)
  7. NULLABLE short => can you use NULL for this type?
     - typeNoNulls - does not allow NULL values
     - typeNullable - allows NULL values
     - typeNullableUnknown - nullability unknown
  8. CASE_SENSITIVE boolean=> is it case sensitive?
  9. SEARCHABLE short => can you use "WHERE" based on this type:
     - typePredNone - No support
     - typePredChar - Only supported with WHERE .. LIKE
     - typePredBasic - Supported except for WHERE .. LIKE
     - typeSearchable - Supported for all WHERE ..
  10. UNSIGNED_ATTRIBUTE boolean => is it unsigned?
  11. FIXED_PREC_SCALE boolean => can it be a money value?
  12. AUTO_INCREMENT boolean => can it be used for an auto-increment value?
  13. LOCAL_TYPE_NAME String => localized version of type name (may be null)
  14. MINIMUM_SCALE short => minimum scale supported
  15. MAXIMUM_SCALE short => maximum scale supported
  16. SQL_DATA_TYPE int => unused
  17. SQL_DATETIME_SUB int => unused
  18. NUM_PREC_RADIX int => usually 2 or 10

  Specified by:
    `getTypeInfo` in interface `DatabaseMetaData`
  Returns:
    `ResultSet` - each row is an SQL type description
  Throws:
    `SQLException` - if a database access error occurs

### getIndexInfo

    public ResultSet getIndexInfo(String catalog,
                                  String schema,
                                  String table,
                                  boolean unique,
                                  boolean approximate)
                           throws SQLException

  Gets a description of a table's indices and statistics. They are ordered by NON_UNIQUE, TYPE, INDEX_NAME, and ORDINAL_POSITION.

  Each index column description has the following columns:

  1. TABLE_CAT String => table catalog (may be null)
  2. TABLE_SCHEM String => table schema (may be null)
  3. TABLE_NAME String => table name
  4. NON_UNIQUE boolean => Can index values be non-unique? false when TYPE is tableIndexStatistic
  5. INDEX_QUALIFIER String => index catalog (may be null); null when TYPE is tableIndexStatistic
  6. INDEX_NAME String => index name; null when TYPE is tableIndexStatistic
  7. TYPE short => index type:
     - tableIndexStatistic - this identifies table statistics that are returned in conjuction with a table's index descriptions
     - tableIndexClustered - this is a clustered index
     - tableIndexHashed - this is a hashed index
     - tableIndexOther - this is some other style of index
  8. ORDINAL_POSITION short => column sequence number within index; zero when TYPE is tableIndexStatistic
  9. COLUMN_NAME String => column name; null when TYPE is tableIndexStatistic
  10. ASC_OR_DESC String => column sort sequence, "A" => ascending, "D" => descending, may be null if sort sequence is not supported; null when TYPE is tableIndexStatistic
  11. CARDINALITY int => When TYPE is tableIndexStatistic, then this is the number of rows in the table; otherwise, it is the number of unique values in the index.
  12. PAGES int => When TYPE is tableIndexStatisic then this is the number of pages used for the table, otherwise it is the number of pages used for the current index.
  13. FILTER_CONDITION String => Filter condition, if any. (may be null)

  Specified by:
    `getIndexInfo` in interface `DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    `schema` - a schema name; "" retrieves those without a schema
    `table` - a table name
    `unique` - when true, return only indices for unique values; when false, return indices regardless of whether unique or not
    `approximate` - when true, result is allowed to reflect approximate or out of data values; when false, results are requested to be accurate
  Returns:
    `ResultSet` - each row is an index column description
  Throws:
    `SQLException` - if a database access error occurs

### supportsResultSetType

    public boolean supportsResultSetType(int type)
                                  throws SQLException

  Does the database support the given result set type?

  Specified by:
    `supportsResultSetType` in interface `DatabaseMetaData`
  Parameters:
    `type` - defined in `java.sql.ResultSet`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.2
  See Also:
    `Connection`, What Is in the JDBC 2.0 API

### supportsResultSetConcurrency

    public boolean supportsResultSetConcurrency(int type,
                                                int concurrency)
                                         throws SQLException

  Does the database support the concurrency type in combination with the given result set type?

  Specified by:
    `supportsResultSetConcurrency` in interface `DatabaseMetaData`
  Parameters:
    `type` - defined in `java.sql.ResultSet`
    `concurrency` - type defined in `java.sql.ResultSet`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.2
  See Also:
    `Connection`, What Is in the JDBC 2.0 API

### ownUpdatesAreVisible

    public boolean ownUpdatesAreVisible(int type)
                                 throws SQLException

  Indicates whether a result set's own updates are visible.

  Specified by:
    `ownUpdatesAreVisible` in interface `DatabaseMetaData`
  Parameters:
    `type` - result set type, i.e. ResultSet.TYPE_XXX
  Returns:
    `true` if updates are visible for the result set type; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

### ownDeletesAreVisible

    public boolean ownDeletesAreVisible(int type)
                                 throws SQLException

  Indicates whether a result set's own deletes are visible.

  Specified by:
    `ownDeletesAreVisible` in interface `DatabaseMetaData`
  Parameters:
    `type` - result set type, i.e. ResultSet.TYPE_XXX
  Returns:
    `true` if deletes are visible for the result set type; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

### ownInsertsAreVisible

    public boolean ownInsertsAreVisible(int type)
                                 throws SQLException

  Indicates whether a result set's own inserts are visible.

  Specified by:
    `ownInsertsAreVisible` in interface `DatabaseMetaData`
  Parameters:
    `type` - result set type, i.e. ResultSet.TYPE_XXX
  Returns:
    `true` if inserts are visible for the result set type; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

### othersUpdatesAreVisible

    public boolean othersUpdatesAreVisible(int type)
                                    throws SQLException

  Indicates whether updates made by others are visible.

  Specified by:
    `othersUpdatesAreVisible` in interface `DatabaseMetaData`
  Parameters:
    `type` - result set type, i.e. ResultSet.TYPE_XXX
  Returns:
    `true` if updates made by others are visible for the result set type; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

### othersDeletesAreVisible

    public boolean othersDeletesAreVisible(int type)
                                    throws SQLException

  Indicates whether deletes made by others are visible.

  Specified by:
    `othersDeletesAreVisible` in interface `DatabaseMetaData`
  Parameters:
    `type` - result set type, i.e. ResultSet.TYPE_XXX
  Returns:
    `true` if deletes made by others are visible for the result set type; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

### othersInsertsAreVisible

    public boolean othersInsertsAreVisible(int type)
                                    throws SQLException

  Indicates whether inserts made by others are visible.

  Specified by:
    `othersInsertsAreVisible` in interface `DatabaseMetaData`
  Parameters:
    `type` - result set type, i.e. ResultSet.TYPE_XXX
  Returns:
    true if updates are visible for the result set type
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

### updatesAreDetected

    public boolean updatesAreDetected(int type)
                               throws SQLException

  Indicates whether or not a visible row update can be detected by calling the method `ResultSet.rowUpdated`.

  Specified by:
    `updatesAreDetected` in interface `DatabaseMetaData`
  Parameters:
    `type` - result set type, i.e. ResultSet.TYPE_XXX
  Returns:
    `true` if changes are detected by the result set type; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

### deletesAreDetected

    public boolean deletesAreDetected(int type)
                               throws SQLException

  Indicates whether or not a visible row delete can be detected by calling ResultSet.rowDeleted(). If deletesAreDetected() returns false, then deleted rows are removed from the result set.

  Specified by:
    `deletesAreDetected` in interface `DatabaseMetaData`
  Parameters:
    `type` - result set type, i.e. ResultSet.TYPE_XXX
  Returns:
    true if changes are detected by the resultset type
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

### insertsAreDetected

    public boolean insertsAreDetected(int type)
                               throws SQLException

  Indicates whether or not a visible row insert can be detected by calling ResultSet.rowInserted().

  Specified by:
    `insertsAreDetected` in interface `DatabaseMetaData`
  Parameters:
    `type` - result set type, i.e. ResultSet.TYPE_XXX
  Returns:
    true if changes are detected by the resultset type
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

### supportsBatchUpdates

    public boolean supportsBatchUpdates()
                                 throws SQLException

  Indicates whether the driver supports batch updates.

  Specified by:
    `supportsBatchUpdates` in interface `DatabaseMetaData`
  Returns:
    true if the driver supports batch updates; false otherwise
  Throws:
    `SQLException`
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

### getUDTs

    public ResultSet getUDTs(String catalog,
                             String schemaPattern,
                             String typeNamePattern,
                             int[] types)
                      throws SQLException

  Gets a description of the user-defined types defined in a particular schema. Schema-specific UDTs may have type JAVA_OBJECT, STRUCT, or DISTINCT.

  Only types matching the catalog, schema, type name and type criteria are returned. They are ordered by DATA_TYPE, TYPE_SCHEM and TYPE_NAME. The type name parameter may be a fully-qualified name. In this case, the catalog and schemaPattern parameters are ignored.

  Each type description has the following columns:

  1. TYPE_CAT String => the type's catalog (may be null)
  2. TYPE_SCHEM String => type's schema (may be null)
  3. TYPE_NAME String => type name
  4. CLASS_NAME String => Java class name
  5. DATA_TYPE String => type value defined in java.sql.Types. One of JAVA_OBJECT, STRUCT, or DISTINCT
  6. REMARKS String => explanatory comment on the type

  Note: If the driver does not support UDTs, an empty result set is returned.

  Specified by:
    `getUDTs` in interface `DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    `schemaPattern` - a schema name pattern; "" retrieves those without a schema
    `typeNamePattern` - a type name pattern; may be a fully-qualified name
    `types` - a list of user-named types to include (JAVA_OBJECT, STRUCT, or DISTINCT); null returns all types
  Returns:
    `ResultSet` - each row is a type description
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

### getConnection

    public Connection getConnection()
                             throws SQLException

  Retrieves the connection that produced this metadata object.

  Specified by:
    `getConnection` in interface `DatabaseMetaData`
  Returns:
    the connection that produced this metadata object
  Throws:
    `SQLException`
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

### getAttributes

    public ResultSet getAttributes(String param1,
                                   String param2,
                                   String param3,
                                   String param4)
                            throws SQLException

  This operation is not supported

  Specified by:
    `getAttributes` in interface `DatabaseMetaData`
  Parameters:
    `param1` - <description>
    `param2` - <description>
    `param3` - <description>
    `param4` - <description>
  Returns:
    <description>
  Throws:
    `SQLException` - <description>

### supportsSavepoints

    public boolean supportsSavepoints()
                               throws SQLException

  Retrieves whether this database supports savepoints.

  Specified by:
    `supportsSavepoints` in interface `DatabaseMetaData`
  Returns:
    true if savepoints are supported; false otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsNamedParameters

    public boolean supportsNamedParameters()
                                    throws SQLException

  Retrieve whether this database supports named parameters.

  Specified by:
    `supportsNamedParameters` in interface `DatabaseMetaData`
  Returns:
    true if named parameters are supported, false otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsMultipleOpenResults

    public boolean supportsMultipleOpenResults()
                                        throws SQLException

  Retrieves whether it is possible to have multiple `ResultSet` objects returned from a `CallableStatement` object simultaneously.

  Specified by:
    `supportsMultipleOpenResults` in interface `DatabaseMetaData`
  Returns:
    true if multiple open ResultSets are supported, false otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsGetGeneratedKeys

    public boolean supportsGetGeneratedKeys()
                                     throws SQLException

  Retrieves whether auto-generated keys can be retrieved after creation.

  Specified by:
    `supportsGetGeneratedKeys` in interface `DatabaseMetaData`
  Returns:
    true if auto-generated keys can be retrieved, false otherwise
  Throws:
    `SQLException` - if a database access error occurs

### getSuperTypes

    public ResultSet getSuperTypes(String catalog,
                                   String schemaPattern,
                                   String tableNamePattern)
                            throws SQLException

  Retrieves a description of the user-defined type (UDT) hierarchies defined in a particular schema in this database. Only the immediate super type/sub type relationship is modeled.

  Only supertype information for UDTs matching the catalog, schema, and type name is returned. The type name parameter may be a fully-qualified name. When the UDT name supplied is a fully-qualified name, the catalog and schemaPattern parameters are ignored.

  If a UDT does not have a direct super type, it is not listed here. A row of the `ResultSet` object returned by this method describes the designated UDT and a direct supertype. A row has the following columns:

  1. TYPE_CAT String => the UDT's catalog (may be `null`)
  2. TYPE_SCHEM String => UDT's schema (may be `null`)
  3. TYPE_NAME String => type name of the UDT
  4. SUPERTYPE_CAT String => the direct super type's catalog (may be `null`)
  5. SUPERTYPE_SCHEM String => the direct super type's schema (may be `null`)
  6. SUPERTYPE_NAME String => the direct super type's name

  Note: If the driver does not support type hierarchies, an empty result set is returned.

  Specified by:
    `getSuperTypes` in interface `DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; "" retrieves those without a catalog; `null` means drop catalog name from the selection criteria
    `schemaPattern` - a schema name pattern; "" retrieves those without a schema
    `tableNamePattern` - a UDT name pattern; may be a fully-qualified name
  Returns:
    a `ResultSet` object in which a row gives information about the designated UDT
  Throws:
    `SQLException` - if a database access error occurs

### getSuperTables

    public ResultSet getSuperTables(String catalog,
                                    String schemaPattern,
                                    String tableNamePattern)
                             throws SQLException

  Retrieves a description of the table hierarchies defined in a particular schema in this database.

  Only supertable information for tables matching the catalog, schema and table name are returned. The table name parameter may be a fully- qualified name, in which case, the catalog and schemaPattern parameters are ignored. If a table does not have a super table, it is not listed here. Supertables have to be defined in the same catalog and schema as the sub tables. Therefore, the type description does not need to include this information for the supertable.

  Each type description has the following columns:

  1. TABLE_CAT String => the type's catalog (may be `null`)
  2. TABLE_SCHEM String => type's schema (may be `null`)
  3. TABLE_NAME String => type name
  4. SUPERTABLE_NAME String => the direct super type's name

  Note: If the driver does not support type hierarchies, an empty result set is returned.

  Specified by:
    `getSuperTables` in interface `DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; "" retrieves those without a catalog; `null` means drop catalog name from the selection criteria
    `schemaPattern` - a schema name pattern; "" retrieves those without a schema
    `tableNamePattern` - a table name pattern; may be a fully-qualified name
  Returns:
    a `ResultSet` object in which each row is a type description
  Throws:
    `SQLException` - if a database access error occurs

### supportsResultSetHoldability

    public boolean supportsResultSetHoldability(int holdability)
                                         throws SQLException

  Retrieves whether this database supports the given results holdability.

  Specified by:
    `supportsResultSetHoldability` in interface `DatabaseMetaData`
  Parameters:
    `holdability` - one of the following constants: `ResultSet.HOLD_CURSORS_OVER_COMMIT` or `ResultSet.CLOSE_CURSORS_AT_COMMIT`
  Returns:
    `true` if the holdability is supported, `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### getResultSetHoldability

    public int getResultSetHoldability()
                                throws SQLException

  Retrieves the default holdability of this `ResultSet`.

  Specified by:
    `getResultSetHoldability` in interface `DatabaseMetaData`
  Returns:
    the default holdability
  Throws:
    `SQLException` - if a database access error occurs

### getDatabaseMajorVersion

    public int getDatabaseMajorVersion()
                                throws SQLException

  Get the major version number of the database.

  Specified by:
    `getDatabaseMajorVersion` in interface `DatabaseMetaData`
  Specified by:
    `getDatabaseMajorVersion` in interface `FirebirdDatabaseMetaData`
  Returns:
    The major version number
  Throws:
    `SQLException` - if a database access error occurs

### getDatabaseMinorVersion

    public int getDatabaseMinorVersion()
                                throws SQLException

  Get the minor version number of the database.

  Specified by:
    `getDatabaseMinorVersion` in interface `DatabaseMetaData`
  Specified by:
    `getDatabaseMinorVersion` in interface `FirebirdDatabaseMetaData`
  Returns:
    The minor version number
  Throws:
    `SQLException` - if a database access error occurs

### getJDBCMajorVersion

    public int getJDBCMajorVersion()
                            throws SQLException

  Get the JDBC major version for this driver.

  Specified by:
    `getJDBCMajorVersion` in interface `DatabaseMetaData`
  Returns:
    the JDBC major version
  Throws:
    `SQLException` - should never be thrown in this implementation

### getJDBCMinorVersion

    public int getJDBCMinorVersion()
                            throws SQLException

  Get the JDBC minor version for this driver

  Specified by:
    `getJDBCMinorVersion` in interface `DatabaseMetaData`
  Returns:
    the JDBC minor version
  Throws:
    `SQLException` - should never be thrown in this implementation

### getSQLStateType

    public int getSQLStateType()
                        throws SQLException

  Indicates whether the SQLSTATEs returned by SQLException.getSQLState is X/Open (now known as Open Group) SQL CLI or SQL99

  Specified by:
    `getSQLStateType` in interface `DatabaseMetaData`
  Returns:
    the type of SQLSTATEs
  Throws:
    `SQLException` - should never be thrown in this implementation

### hasNoWildcards

    public boolean hasNoWildcards(String pattern)

  Determine if there are no SQL wildcard characters ('%' or '_') in the given pattern.

  Parameters:
    `pattern` - The pattern to be checked for wildcards
  Returns:
    `true` if there are no wildcards in the pattern, `false` otherwise

### stripEscape

    public String stripEscape(String pattern)

  Strips all backslash-escapes from a string.

  Parameters:
    `pattern` - The string to be stripped
  Returns:
    pattern with all backslash-escapes removed

### stripQuotes

    public String stripQuotes(String pattern,
                              boolean uppercase)

  Strips a leading and trailing quote (double or single) from a string.

  Parameters:
    `pattern` - the string to be stripped
  Returns:
    a copy of `pattern` with leading and trailing quote removed

### getProcedureSourceCode

    public String getProcedureSourceCode(String procedureName)
                                  throws SQLException

  Description copied from interface: `FirebirdDatabaseMetaData`
  Get the source of a stored procedure.

  Specified by:
    `getProcedureSourceCode` in interface `FirebirdDatabaseMetaData`
  Parameters:
    `procedureName` - name of the stored procedure.
  Returns:
    source of the stored procedure.
  Throws:
    `SQLException` - if specified procedure cannot be found.

### getTriggerSourceCode

    public String getTriggerSourceCode(String triggerName)
                                throws SQLException

  Description copied from interface: `FirebirdDatabaseMetaData`
  Get the source of a trigger.

  Specified by:
    `getTriggerSourceCode` in interface `FirebirdDatabaseMetaData`
  Parameters:
    `triggerName` - name of the trigger.
  Returns:
    source of the trigger.
  Throws:
    `SQLException` - if specified trigger cannot be found.

### getViewSourceCode

    public String getViewSourceCode(String viewName)
                             throws SQLException

  Description copied from interface: `FirebirdDatabaseMetaData`
  Get the source of a view.

  Specified by:
    `getViewSourceCode` in interface `FirebirdDatabaseMetaData`
  Parameters:
    `viewName` - name of the view.
  Returns:
    source of the view.
  Throws:
    `SQLException` - if specified view cannot be found.

### doQuery

    public ResultSet doQuery(String sql,
                             List params)
                      throws SQLException

  Execute an sql query with a given set of parameters.

  Parameters:
    `sql` - The sql statement to be used for the query
    `params` - The parameters to be used in the query
  Throws:
    `SQLException` - if a database access error occurs

Copyright © 2001-2010. All Rights Reserved.